require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let FRCOMP_POP_GRID_LIST = '/api/frcomp/pop-grid-list';

function itp_fn_BIZPOP_FRCOMP(parentPopFn, args, returnType) {
	// 공통코드
	fn_make_select(CODE_LIST, 'CMPY_TYPE_CD', 'ITP_FORM_BIZPOP_FRCOMP_CMPY_TYPE_CD', true, '브랜드그룹타입 선택');
	
	let itp_BIZPOP_FRCOMP_param = {};
	let itp_BIZPOP_FRCOMP_search = false;

	const THIS_FORM_ID = '#ITP_FORM_BIZPOP_FRCOMP';
	const THIS_GIRD_ID = '#ITP_BIZPOP_FRCOMP_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_FRCOMP_jqGridPager';
	
	$('#ITP_BIZPOP_FRCOMP').one('shown.bs.modal', function(e) {
		itp_fn_jqgrid_resize(THIS_GIRD_ID, '#ITP_BIZPOP_FRCOMP_jqGrid_list', '');
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_FRCOMP').remove();
	}).modal('show');

	$('#ITP_BIZPOP_FRCOMP_BTN_SEARCH').on('click', function() {
		itp_BIZPOP_FRCOMP_search = true;
		let param = $(THIS_FORM_ID).serializeObject();
		param.gridSize = 10;
		param.gridPage = $.jgrid.defaults.page;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
	});
	
	$('#ITP_BIZPOP_FRCOMP_BTN_SELECT').on('click', function() {		
		const rowKey = $(THIS_GIRD_ID).getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }

		var list = [];
	    var selectedIds = $(THIS_GIRD_ID).getGridParam('selarrrow');

		if(selectedIds.length > 1) { // 1개만 선택
			return;
		} 
		
	    for (var i=selectedIds.length-1; i>=0; i--) {
			list.push($(THIS_GIRD_ID).jqGrid('getRowData', selectedIds[i]));	
		}
		parentPopFn(list);
		$('#ITP_BIZPOP_FRCOMP').modal('hide'); // 팝업닫기
	});

	$('#ITP_BIZPOP_FRCOMP_jqGridEmpty').on('click', function() {
		itp_fn_BIZPOP_FRCOMP_empty.back();
		itp_BIZPOP_FRCOMP_param.gridSize = 10;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(itp_BIZPOP_FRCOMP_param)}).trigger('reloadGrid');
	});

	var itp_fn_BIZPOP_FRCOMP_empty = {
		push: function() {
			let param = $(THIS_FORM_ID).serializeObject();
			itp_BIZPOP_FRCOMP_param = param;
		},
		back: function() {
			$(THIS_FORM_ID + '_CMPY_CD').val(itp_BIZPOP_FRCOMP_param.scmpyCd);
			$(THIS_FORM_ID + '_CMPY_NM').val(itp_BIZPOP_FRCOMP_param.scmpyNm);
			$(THIS_FORM_ID + '_CMPY_TYPE_CD').val(itp_BIZPOP_FRCOMP_param.scmpyTypeCd);
		}
	};

	itp_fn_BIZPOP_FRCOMP_empty.push();
	let param = $('#ITP_FORM_BIZPOP_FRCOMP').serializeObject();
	param.gridSize = 10;

	$(THIS_GIRD_ID).jqGrid({
		colModel: [
			{
				index: 'CMPY_CD', name: 'cmpyCd',
				label: '브랜드그룹코드', // 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CMPY_NM', name: 'cmpyNm',
				label: '브랜드그룹명', //
				width: '12', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CMPY_TYPE_NM', name: 'cmpyTypeNm',
				label: '타입', //
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CMPY_REG_NUM', name: 'cmpyRegNum',
				label: '사업자등록번호', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		],
		loadBeforeSend: function(jqXHR) {
		    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
		},
		postData: JSON.stringify(param),
		url: DOMAIN + FRCOMP_POP_GRID_LIST,
		pager: THIS_GIRD_PAGER,
		multiselect: true,
		loadComplete: function(data) {
			itp_fn_grid_load_complete(data, THIS_GIRD_ID, true, undefined, 'BIZPOP_FRCOMP', itp_BIZPOP_FRCOMP_search, itp_fn_BIZPOP_FRCOMP_empty, true, data.gridRecords, false);
	    },
	    loadError: function(jqXHR, textStatus, errorThrown) {
	    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
	    },
	    onPaging: function(action) {
	    	itp_fn_grid_paging(THIS_GIRD_ID, action, param);
	    }
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
};
